# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *
import dataclasses

V_3D_NWARP_XYZ_METADATA = Metadata(
    id="39acc6806ae751e967e1a41bdfd3fa44c32ceb39.boutiques",
    name="3dNwarpXYZ",
    package="afni",
    container_image_tag="afni/afni_make_build:AFNI_24.2.06",
)


class V3dNwarpXyzOutputs(typing.NamedTuple):
    """
    Output object returned when calling `v_3d_nwarp_xyz(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""
    output_file: OutputPathType
    """Warped XYZ coordinates output file"""


def v_3d_nwarp_xyz(
    xyzfile: InputPathType,
    runner: Runner | None = None,
) -> V3dNwarpXyzOutputs:
    """
    Transforms the DICOM xyz coordinates in the input XYZfile.1D based on specified
    warp.
    
    Author: AFNI Team
    
    URL: https://afni.nimh.nih.gov/pub/dist/doc/program_help/3dNwarpXYZ.html
    
    Args:
        xyzfile: XYZ coordinate file containing 3 columns.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `V3dNwarpXyzOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(V_3D_NWARP_XYZ_METADATA)
    cargs = []
    cargs.append("3dNwarpXYZ")
    cargs.append("[OPTIONS]")
    cargs.append("-nwarp")
    cargs.append("[WARP_SPEC]")
    cargs.append(execution.input_file(xyzfile))
    cargs.append(">")
    cargs.append("[OUTPUT_FILE]")
    ret = V3dNwarpXyzOutputs(
        root=execution.output_file("."),
        output_file=execution.output_file("[OUTPUT_FILE]"),
    )
    execution.run(cargs)
    return ret


__all__ = [
    "V3dNwarpXyzOutputs",
    "V_3D_NWARP_XYZ_METADATA",
    "v_3d_nwarp_xyz",
]
