# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *
import dataclasses

V__INSTALL_FATCAT_DEMO_METADATA = Metadata(
    id="26d953b29408de10d52434e402c521276810822d.boutiques",
    name="@Install_FATCAT_DEMO",
    package="afni",
    container_image_tag="afni/afni_make_build:AFNI_24.2.06",
)


class VInstallFatcatDemoOutputs(typing.NamedTuple):
    """
    Output object returned when calling `v__install_fatcat_demo(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""


def v__install_fatcat_demo(
    wget: bool = False,
    curl: bool = False,
    runner: Runner | None = None,
) -> VInstallFatcatDemoOutputs:
    """
    Installs the demo archive for Paul Taylor's tractography tools.
    
    Author: AFNI Team
    
    URL:
    https://afni.nimh.nih.gov/pub/dist/doc/program_help/@Install_FATCAT_DEMO.html
    
    Args:
        wget: Use wget to download archive. Script chooses by default with\
            preference for curl.
        curl: Use curl to download archive. Script chooses by default with\
            preference for curl.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `VInstallFatcatDemoOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(V__INSTALL_FATCAT_DEMO_METADATA)
    cargs = []
    cargs.append("@Install_FATCAT_DEMO")
    if wget:
        cargs.append("-wget")
    if curl:
        cargs.append("-curl")
    ret = VInstallFatcatDemoOutputs(
        root=execution.output_file("."),
    )
    execution.run(cargs)
    return ret


__all__ = [
    "VInstallFatcatDemoOutputs",
    "V__INSTALL_FATCAT_DEMO_METADATA",
    "v__install_fatcat_demo",
]
