# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *
import dataclasses

V__INSTALL_IBT_DATASETS_METADATA = Metadata(
    id="62a4759b15ff3c40ab34f0a774c8db4548a18840.boutiques",
    name="@Install_IBT_DATASETS",
    package="afni",
    container_image_tag="afni/afni_make_build:AFNI_24.2.06",
)


class VInstallIbtDatasetsOutputs(typing.NamedTuple):
    """
    Output object returned when calling `v__install_ibt_datasets(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""


def v__install_ibt_datasets(
    wget_flag: bool = False,
    curl_flag: bool = False,
    runner: Runner | None = None,
) -> VInstallIbtDatasetsOutputs:
    """
    Installs the demo archive for AFNI's macaque-analysis demo.
    
    Author: AFNI Team
    
    URL:
    https://afni.nimh.nih.gov/pub/dist/doc/program_help/@Install_IBT_DATASETS.html
    
    Args:
        wget_flag: Use wget to download archive. Script chooses by default with\
            preference for curl.
        curl_flag: Use curl to download archive. Script chooses by default with\
            preference for curl.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `VInstallIbtDatasetsOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(V__INSTALL_IBT_DATASETS_METADATA)
    cargs = []
    cargs.append("Install_IBT_DATASETS")
    if wget_flag:
        cargs.append("-wget")
    if curl_flag:
        cargs.append("-curl")
    ret = VInstallIbtDatasetsOutputs(
        root=execution.output_file("."),
    )
    execution.run(cargs)
    return ret


__all__ = [
    "VInstallIbtDatasetsOutputs",
    "V__INSTALL_IBT_DATASETS_METADATA",
    "v__install_ibt_datasets",
]
