# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *
import dataclasses

FSLVAL_METADATA = Metadata(
    id="6702c1f18f6fd097e54c88bdbc672f8c2039bf7c.boutiques",
    name="fslval",
    package="fsl",
    container_image_tag="mcin/fsl:6.0.5",
)


class FslvalOutputs(typing.NamedTuple):
    """
    Output object returned when calling `fslval(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""
    stdout: OutputPathType
    """Output printed to standard out"""


def fslval(
    input_file: InputPathType,
    keyword_: str,
    runner: Runner | None = None,
) -> FslvalOutputs:
    """
    Tool for printing out header information from NIfTI image files.
    
    Author: Oxford Centre for Functional MRI of the Brain (FMRIB)
    
    URL: https://fsl.fmrib.ox.ac.uk/fsl/fslwiki/Fslutils
    
    Args:
        input_file: Input NIfTI image file.
        keyword_: Keyword to query from the NIfTI header.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `FslvalOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(FSLVAL_METADATA)
    cargs = []
    cargs.append("fslval")
    cargs.append(execution.input_file(input_file))
    cargs.append(keyword_)
    ret = FslvalOutputs(
        root=execution.output_file("."),
        stdout=execution.output_file("stdout"),
    )
    execution.run(cargs)
    return ret


__all__ = [
    "FSLVAL_METADATA",
    "FslvalOutputs",
    "fslval",
]
