# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *
import dataclasses

PROJ_THRESH_METADATA = Metadata(
    id="e3776dfaa76fb62791a030b9053716c89b7c328b.boutiques",
    name="proj_thresh",
    package="fsl",
    container_image_tag="mcin/fsl:6.0.5",
)


class ProjThreshOutputs(typing.NamedTuple):
    """
    Output object returned when calling `proj_thresh(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""


def proj_thresh(
    input_paths: list[InputPathType],
    threshold: float,
    runner: Runner | None = None,
) -> ProjThreshOutputs:
    """
    A tool to apply a threshold to either volumes or surfaces.
    
    Author: Unknown
    
    Args:
        input_paths: Paths to volume or surface files. Please use either\
            volumes or surfaces but not both.
        threshold: Threshold value to be applied.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `ProjThreshOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(PROJ_THRESH_METADATA)
    cargs = []
    cargs.append("proj_thresh")
    cargs.extend([execution.input_file(f) for f in input_paths])
    cargs.append(str(threshold))
    ret = ProjThreshOutputs(
        root=execution.output_file("."),
    )
    execution.run(cargs)
    return ret


__all__ = [
    "PROJ_THRESH_METADATA",
    "ProjThreshOutputs",
    "proj_thresh",
]
