# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *
import dataclasses

TBSS_X_METADATA = Metadata(
    id="582c24e736807594d96e54b5b8e8b34c1a775937.boutiques",
    name="tbss_x",
    package="fsl",
    container_image_tag="mcin/fsl:6.0.5",
)


class TbssXOutputs(typing.NamedTuple):
    """
    Output object returned when calling `tbss_x(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""


def tbss_x(
    scalar_dirs: list[str],
    vector_dirs: list[str],
    runner: Runner | None = None,
) -> TbssXOutputs:
    """
    TBSS cross-subject script for processing scalar and vector directories.
    
    Author: FMRIB Software Library (FSL)
    
    URL: https://fsl.fmrib.ox.ac.uk/fsl/fslwiki/TBSS
    
    Args:
        scalar_dirs: List of scalar directories (e.g., F1, F2).
        vector_dirs: List of vector directories (e.g., D1, D2).
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `TbssXOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(TBSS_X_METADATA)
    cargs = []
    cargs.append("tbss_x")
    cargs.extend(scalar_dirs)
    cargs.extend(vector_dirs)
    ret = TbssXOutputs(
        root=execution.output_file("."),
    )
    execution.run(cargs)
    return ret


__all__ = [
    "TBSS_X_METADATA",
    "TbssXOutputs",
    "tbss_x",
]
